<template>
  <v-data-table
    :headers="vehicleHeaders"
    :items="vehicleDetails"
    show-expand
    hide-default-header
    hide-default-footer
  >
    <template #item.details="{ index, item }">
      Vehículo {{ hashId({ id: index, zeros: 3 }) }} {{ vehiclePlate(item) }}
    </template>
    <template #item.space1="{ }">
      <p> </p>
    </template>
    <template #item.space2="{ }">
      <p> </p>
    </template>

    <template #expanded-item="{ headers, item }">
      <td :colspan="headers.length">
        <vehicle-details
          :id="item.orderIdsToDispatch[0]"
          :details="item"
          class="mx-3 my-10"
        />
      </td>
    </template>
  </v-data-table>
</template>

<script>
import { mapState } from 'vuex';
import VehicleDetails from './VehicleDetails';
import { hashId, withZeros } from '~/helpers/format/ids';

export default {
  name: 'VehiclesToDispatch',
  components: {
    VehicleDetails,
  },
  data: () => ({
    vehicleHeaders: [
      { text: 'Detalles', align: 'start', sortable: false, value: 'details' },
      { text: 'Espacio 01', align: 'start', sortable: false, value: 'space1' },
      { text: 'Espacio 02', align: 'start', sortable: false, value: 'space2' },
    ],
  }),
  computed: {
    ...mapState({
      dispatch: state => state.programming.dispatches.current.dispatch,
      orders: state => state.programming.dispatches.current.orders,
      vehicleDetails: state => state.programming.dispatches.current.vehicleDetails,
    }),
  },
  methods: {
    hashId,
    withZeros,
    vehiclePlate(vehicleDetail) {
      const plate = vehicleDetail?.vehicle?.plate ?? null;
      if (!plate) {
        return '';
      }

      return `- ${plate}`;
    },
  },
};
</script>
